/*
 * Copyright (c) 1992-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

#ifndef lint
static char *RCSid = "$Header: /src/common/usc/bin/sysinfo/RCS/getosname.c,v 1.2 1993/04/09 01:34:38 mcooper Exp mcooper $";
#endif

/*
 * Get OS name information
 */

#include "defs.h"

#if	defined(HAVE_SYSINFO)
/*
 * Get OS name using sysinfo() system call.
 */
static char *GetOSNameFromSysinfo()
{
    static char			buff[BUFSIZ];

    if (buff[0])
	return(buff);

    if (sysinfo(SI_SYSNAME, buff, sizeof(buff)) < 0)
	return((char *) NULL);

    return(buff);
}
#endif	/* HAVE_SYSINFO */

#if	defined(HAVE_UNAME)
/*
 * Get name of OS using uname()
 */
static char *GetOSNameFromUname()
{
    static struct utsname 	un;

    if (uname(&un) != 0)
	return((char *) NULL);
    else
	return(un.sysname);
}
#endif	/* HAVE_UNAME */

/*
 * Get Operating System name.
 */
extern char *GetOSName()
{
    static char		       *osname = NULL;

    if (osname)
	return(osname);

#if	defined(OS_NAME)
    if (!osname)
	osname = OS_NAME;
#endif	/* OS_NAME */

#if	defined(HAVE_SYSINFO)
    if (!osname)
	osname = GetOSNameFromSysinfo();
#endif	/* HAVE_SYSINFO */

#if	defined(HAVE_UNAME)
    if (!osname)
	osname = GetOSNameFromUname();
#endif	/* HAVE_UNAME */

    return(osname);
}

