/*
 * Copyright (c) 1992-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

#ifndef lint
static char *RCSid = "$Header: /src/common/usc/bin/sysinfo/RCS/info-aix.c,v 1.7 1993/02/11 21:43:13 mcooper Exp mcooper $";
#endif


/*
 * AIX related information
 */

#include <stdio.h>
#include "defs.h"

/*
 * These values were gleamed from a copy of the
 * AIXpert magazine.
 */
NAMETAB ModelTab[] = {
    { 0x0031, 	"RS/6000 320" },
    { 0x0035, 	"RS/6000 320H" },
    { 0x0030, 	"RS/6000 520" },
    { 0x0010, 	"RS/6000 [57]30" },
    { 0x0018, 	"RS/6000 530H" },
    { 0x0014, 	"RS/6000 540" },
    { 0x001C, 	"RS/6000 550" },
    { 0x0020, 	"RS/6000 930" },
    { 0x002E, 	"RS/6000 950" },
    { 0x0102, 	"RS/6000 970" },
    { 0 },
};

/*
 * Device Data Table
 *
 * Only devices that don't have full descriptions in the device catalog
 * file, should be listed here.
 */
extern DEVICE *ProbeMemory();

DEVDATATAB DevDataTab[] = {
    { "mem",		DT_MEMORY,	NULL,	NULL,	ProbeMemory },
    {  0 },
};

/*
 * Vital Product Data definetions.
 */
vpdinfo_t VPDinfo[] = {
    { "DL",	"Drawer Level" },
    { "EC",	"EC Level" },
    { "FC",	"Feature Code" },
    { "FN",	"FRU Number" },
    { "LL",	"Loadable ROM Level" },
    { "MF",	"Manufacturer" },
    { "PC",	"Processor Component" },
    { "PI",	"Processor ID" },
    { "PN",	"Part Number" },
    { "RL",	"ROM Level" },
    { "RN",	"Rack Name" },
    { "SL",	"Slot Location" },
    { "SN",	"Serial Number" },
    { "SZ",	"Size" },
    { "TM",	"Model" },
#if 0	/* We don't care about these */
    { "Z0",	"Processor Chip" },
    { "Z3",	"SIMM Product definetion" },
#endif
    { 0 },
};
