/*
 * Copyright (c) 1992-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

#ifndef lint
static char *RCSid = "$Header: /src/common/usc/bin/sysinfo/RCS/info-sunos.c,v 1.54 1993/04/21 03:04:46 mcooper Exp mcooper $";
#endif


/*
 * SunOS specific device info
 */

#include "defs.h"

#include <sys/types.h>
#include <sys/buf.h>
#include <sys/mtio.h>

/*
 * RomVec
 */
char 				RomVecSYM[] = "_romp";

/*
 * idprom
 */
char 				IdpromSYM[] = "_idprom";

#if	defined(HAVE_MAINBUS)
/*
 * MainBus symbol
 */
char 				MainBusSYM[] = "_mbdinit";
#endif	/* HAVE_MAINBUS */

#if	defined(HAVE_OPENPROM)
/*
 * OpenPROM symbol
 */
char 				OpenPROMSYM[] = "_top_devinfo";
#endif	/* HAVE_OPENPROM */


/*
 * Sun system model table
 *
 * Not all values are real machines.  What is found below is
 * extracted from /usr/include/{sun3,sun3x,sun4,sun4c,sun4m}/cpu.h.
 */
NAMETAB ModelTab[] = {
/*
 * Sun-3 CPU's
 */
#ifdef CPU_SUN3_50
    {  CPU_SUN3_50,	 	"3/50" },
#endif
#ifdef CPU_SUN3_60
    {  CPU_SUN3_60,	 	"3/60" },
#endif
#ifdef CPU_SUN3_E
    {  CPU_SUN3_E,	    	"3/Eurocard" },
#endif
#ifdef CPU_SUN3_110
    {  CPU_SUN3_110,	    	"3/110" },
#endif
#ifdef CPU_SUN3_160
    {  CPU_SUN3_160,	    	"3/100 Series" },
#endif
#ifdef CPU_SUN3_260
    {  CPU_SUN3_260,	    	"3/200 Series" },
#endif

/*
 * Sun-3x CPU's
 */
#ifdef CPU_SUN3X_80
    {  CPU_SUN3X_80,		"3/80" },
#endif
#ifdef CPU_SUN3X_470
    {  CPU_SUN3X_470,		"3/400 Series" },
#endif

/*
 * Sun-4c CPU's.
 */
#ifdef CPU_SUN4C_05
    {  CPU_SUN4C_05,		"4/05" },
#endif
#ifdef CPU_SUN4C_10
    {  CPU_SUN4C_10,		"4/10" },
#endif
#ifdef CPU_SUN4C_20
    {  CPU_SUN4C_20,		"4/20 (SPARCstation SLC)" },
#endif
/*
 * XXX The 4/25 and 4/30 are both ELC's depending on your OS
 */
#ifdef CPU_SUN4C_25
    {  CPU_SUN4C_25,		"4/25 (SPARCstation ELC)" },
#endif
#ifdef CPU_SUN4C_30
    {  CPU_SUN4C_30,		"4/30 (SPARCstation ELC)" },
#endif
#ifdef CPU_SUN4C_32
    {  CPU_SUN4C_32,		"4/32" },
#endif
#ifdef CPU_SUN4C_40
    {  CPU_SUN4C_40,		"4/40 (SPARCstation IPC)" },
#endif
#ifdef CPU_SUN4C_45
    {  CPU_SUN4C_45,		"4/45" },
#endif
#ifdef CPU_SUN4C_50
    {  CPU_SUN4C_50,		"4/50 (SPARCstation IPX)" },
#endif
#ifdef CPU_SUN4C_60
    {  CPU_SUN4C_60,		"4/60 (SPARCstation 1)" },
#endif
#ifdef CPU_SUN4C_65
    {  CPU_SUN4C_65,		"4/65 (SPARCstation 1+)" },
#endif
#ifdef CPU_SUN4C_70
    {  CPU_SUN4C_70,		"4/70" },
#endif
#ifdef CPU_SUN4C_75
    {  CPU_SUN4C_75,		"4/75 (SPARCstation 2)" },
#endif
#ifdef CPU_SUN4C_80
    {  CPU_SUN4C_80,		"4/80" },
#endif
#ifdef CPU_SUN4C_85
    {  CPU_SUN4C_85,		"4/85" },
#endif

/*
 * Sun-4 CPU's
 */
#ifdef CPU_SUN4_110
    {  CPU_SUN4_110,	    	"4/110" },
#endif
#ifdef CPU_SUN4_260
    {  CPU_SUN4_260,	    	"4/200 Series" },
#endif
#ifdef CPU_SUN4_330
    {  CPU_SUN4_330,		"SPARCsystem 300" },
#endif
#ifdef CPU_SUN4_460	/* Sun changed the 4_460 to 4_470 in 4.1.1 */
    {  CPU_SUN4_460,		"SPARCsystem 400" },
#endif
#ifdef CPU_SUN4_470
    {  CPU_SUN4_470,		"SPARCsystem 400" },
#endif

/*
 * Sun-4m CPU's
 */
#ifdef CPU_SUN4M_50
    {  CPU_SUN4M_50,	    	"SPARCsystem 10" },
#endif
#ifdef CPU_SUN4M_40
    {  CPU_SUN4M_40,	    	"SPARCsystem 4m/40" },	/* XXX ??? */
#endif
#ifdef CPU_SUN4M_60
    {  CPU_SUN4M_60,	    	"SPARCsystem 600" },	/* SunOS 5.x */
#endif
#ifdef CPU_SUN4M_690
    {  CPU_SUN4M_690,	    	"SPARCsystem 600" },	/* SunOS 4.x */
#endif

/*
 * Sun-4e CPU's.
 */
#ifdef CPU_SUN4E_120
    {  CPU_SUN4E_120,	    	"SPARCengine 1E" },
#endif

/*
 * Sun-4d CPU's.
 */
#ifdef CPU_SUN4D
    {  CPU_SUN4D,	    	"Sun4d" },	/* XXX ??? */
#endif

/*
 * Sun-386i CPU's
 */
#ifdef CPU_SUN386_MB1
    {  CPU_SUN386_MB1,		"386i (MB1)" },
#endif
#ifdef CPU_SUN386_150
    /* The 386i/150 and 386i/250 are the same */
    {  CPU_SUN386_150,		"386i" },
#endif

/*
 * Solbourne CPU's
 */
#ifdef CPU_SERIES4_500
    {  CPU_SERIES4_500,		"Series4/500" },
#endif
#ifdef CPU_SERIES4_600
    {  CPU_SERIES4_600,		"Series4/600" },
#endif
#ifdef CPU_SERIES5_500
    {  CPU_SERIES5_500,		"Series5/500" },
#endif
#ifdef CPU_SERIES5_600
    {  CPU_SERIES5_600,		"Series5/600" },
#endif
#ifdef CPU_SERIES5_900
    {  CPU_SERIES5_900,		"Series5/900" },
#endif
#ifdef CPU_SERIES5E_500
    {  CPU_SERIES5E_500,	"Series5E/500" },
#endif
#ifdef CPU_SERIES5E_600
    {  CPU_SERIES5E_600,	"Series5E/600" },
#endif
#ifdef CPU_SERIES5E_900
    {  CPU_SERIES5E_900,	"Series5E/900" },
#endif
#ifdef CPU_SERIES6_500
    {  CPU_SERIES6_500,		"Series6/500" },
#endif
#ifdef CPU_SERIES6_600
    {  CPU_SERIES6_600,		"Series6/600" },
#endif
#ifdef CPU_SERIES6_900
    {  CPU_SERIES6_900,		"Series6/900" },
#endif

/*
 * TadPole CPU's
 */
#ifdef CPU_TAD_SPBK_S1
    {  CPU_TAD_SPBK_S1,		"SPARCbook-1" },
#endif

    { 0 },
};

/*
 * Kernel Architecture table
 */
NAMETAB KernArchTab[] = {
#ifdef SUN386_ARCH
    {  SUN386_ARCH,		"sun386" },
#endif
#ifdef SUN3_ARCH
    {  SUN3_ARCH,		"sun3" },
#endif
#ifdef SUN3X_ARCH
    {  SUN3X_ARCH,		"sun3x" },
#endif
#ifdef SUN4_ARCH
    {  SUN4_ARCH,		"sun4" },
#endif
#ifdef SUN4C_ARCH
    {  SUN4C_ARCH,		"sun4c" },
#endif
#ifdef SUN4D_ARCH
    {  SUN4D_ARCH,		"sun4d" },
#endif
#ifdef SUN4E_ARCH
    {  SUN4E_ARCH,		"sun4e" },
#endif
#ifdef SUN4M_ARCH
    {  SUN4M_ARCH,		"sun4m" },
#endif
/*
 * Tadpole
 */
#ifdef TAD_SPBK_ARCH
    {  TAD_SPBK_ARCH,		"SPARCbook" },
#endif
/*
 * Solbourne
 */
#ifdef CPU_TYPE_SERIES4
    {  CPU_TYPE_SERIES4,	"Series4" },
#endif
#ifdef CPU_TYPE_SERIES5
    {  CPU_TYPE_SERIES5,	"Series5" },
#endif
#ifdef CPU_TYPE_SERIES5E
    {  CPU_TYPE_SERIES5E,	"Series5E" },
#endif
#ifdef CPU_TYPE_SERIES6
    {  CPU_TYPE_SERIES6,	"Series6" },
#endif
#ifdef CPU_TYPE_KAP_M2
    {  CPU_TYPE_KAP_M2,		"KAP_M2" },
#endif
    { 0 },
};

/*
 * Device Data Table
 *
 * Compares are done by the length of the string appearing in
 * the first columns.  Therefore, longer names must appear before
 * any shorter names that are not unique.  e.g. "lebuffer" needs to
 * be before "le".
 */
extern DEVICE *ProbeCDROMDrive();
extern DEVICE *ProbeSPDrive();

DEVDATATAB DevDataTab[] = {
    /*
     * Network Interfaces
     */
    { "ie",
	  "Intel 82586 LAN Co-Processor",	
	  "10Mb/sec Ethernet",				
	  ProbeNetif },
    { "ei",
	  "Solbourne IOASIC AMD Lance Am7990",	
	  "10Mb/sec Ethernet",
	  ProbeNetif },
    { "le",
	  "AMD Lance Am7990",
	  "10Mb/sec Ethernet",
	  ProbeNetif },
    { "ne",
	  "Interphase NC400",
	  "10Mb/sec Ethernet",
	  ProbeNetif },
    { "fddi",
	  "Sun FDDI/DX",
	  "100Mb/sec dual-attach FDDI",
	  ProbeNetif },
    { "bf",
	  "Sun/Bantam FDDI/S",
	  "100Mb/sec single-attach FDDI",
	  ProbeNetif },
    /*
     * Disk Drives
     */
    { "sd",		NULL,	NULL,	ProbeDiskDrive },
    { "xd",		NULL,	NULL,	ProbeDiskDrive },
    { "xl",		NULL,	NULL,	ProbeDiskDrive },
    { "xy",		NULL,	NULL,	ProbeDiskDrive },
    { "id",		NULL,	NULL,	ProbeDiskDrive },
    { "sr",	    "CD-ROM",	NULL,	ProbeCDROMDrive },
    { "fd",	    "Floppy",	NULL,	ProbeDiskDrive },
    { "SUNW,fdtwo", "Floppy",	NULL,	ProbeDiskDrive },
    /*
     * More detailed descriptions of SCSI adapters
     */
    { "esp",
	  "Generic SCSI interface",	NULL,	
	  ProbeGeneric, DT_DISKCTLR },
    { "sc",
	  "Sun SCSI-2 host adapter",	NULL,	
	  ProbeGeneric, DT_DISKCTLR },
    { "si",
	  "Sun SCSI-3 host adapter",	NULL,	
	  ProbeGeneric, DT_DISKCTLR },
    { "sm",
	  "Sun SCSI-ESP host adapter",	NULL,	
	  ProbeGeneric, DT_DISKCTLR },
    { "se",
	  "Sun SCSI-E host adapter",	NULL,	
	  ProbeGeneric, DT_DISKCTLR },
    { "sw",
	  "Sun SCSI-Weird host adapter",NULL,	
	  ProbeGeneric, DT_DISKCTLR },
    /*
     * Tape drives and tape controllers
     */
    { "st",
	  "SCSI",		NULL,	
	  ProbeTapeDrive, DT_TAPEDRIVE },
    { "xtc",
	  "Xylogics 472",	"1/2 inch tape controller", 
	  ProbeGeneric, DT_TAPECTLR },
    { "xt",
	  "Fujitsu M2444",	"1/2 inch tape drive",	
	  ProbeTapeDrive, DT_TAPEDRIVE },
    /*
     * Frame Buffers
     */
    { "bwone",		NULL,	NULL,	ProbeFrameBuffer },
    { "bwtwo",		NULL,	NULL,	ProbeFrameBuffer },
    { "cgone",		NULL,	NULL,	ProbeFrameBuffer },
    { "cgtwo",		NULL,	NULL,	ProbeFrameBuffer },
    { "cgthree",	NULL,	NULL,	ProbeFrameBuffer },
    { "cgfour",		NULL,	NULL,	ProbeFrameBuffer },
    { "cgsix",		NULL,	NULL,	ProbeFrameBuffer },
    { "cgeight",	NULL,	NULL,	ProbeFrameBuffer },
    { "cgnine",		NULL,	NULL,	ProbeFrameBuffer },
    { "cgtwelve",	NULL,	NULL,	ProbeFrameBuffer },
    { "gpone",		NULL,	NULL,	ProbeFrameBuffer },
    { "gt",		NULL,	NULL,	ProbeFrameBuffer },
    { "taac",		NULL,	NULL,	ProbeFrameBuffer },
    { "vx",		NULL,	NULL,	ProbeFrameBuffer },
    /*
     * Bus types
     */
    { "vme",	"VME Bus",			NULL,ProbeGeneric,DT_BUS },
    { "sbus",	"SBus",				NULL,ProbeGeneric,DT_BUS },
    { "obio",	"On Board I/O",			NULL,ProbeGeneric,DT_BUS },
    { "obmem",	"On Board Memory",		NULL,ProbeGeneric,DT_BUS },
    { "iommu",	"I/O Memory Management Unit",	NULL,ProbeGeneric,DT_BUS },
    /*
     * Psuedo and Generic devices.
     */
    { OBP_SYSBOARD,	"System Board",	NULL,ProbeGeneric,DT_GENERIC },
    { "sbi",		"SBus Interface",NULL,ProbeGeneric,DT_GENERIC },
    { "bootbus",	"Boot Bus",	NULL,ProbeGeneric,DT_BUS },
    { "cpu-unit",	"CPU Unit",	NULL,ProbeGeneric,DT_BUS },
    { "io-unit",	"I/O Unit",	NULL,ProbeGeneric,DT_BUS },
    { "mem-unit",	"Memory Unit",	NULL,ProbeGeneric,DT_BUS },
    { "dma",		"DMA Driver",	NULL,ProbeGeneric,DT_GENERIC },
    { "lebuffer", 	"Buffered LANCE Ethernet",	NULL,	
	  				ProbeGeneric,	DT_GENERIC },
    { "espdma",		"SCSI DMA",			NULL,	
	  				ProbeGeneric,	DT_PSEUDO },
    { "ledma",		"LANCE Ethernet DMA",		NULL,	
					ProbeGeneric,	DT_PSEUDO },
    { "openprom", 	"Open Boot PROM",		NULL,	
					ProbeGeneric,	DT_PSEUDO },
    { "pn",		"IPI Bus Connector",		NULL,
					ProbeGeneric,	DT_GENERIC,DDT_LENCMP},
    { "SUNW,pn",	"IPI Bus Connector",		NULL,
					ProbeGeneric,	DT_GENERIC,DDT_LENCMP},
    { "ipi3sc", 	"IPI-3 String Controller",	NULL,
					ProbeGeneric,	DT_GENERIC },
    /*
     * Miscellaneous devices
     */
    { "audio",
	  "AM79C30A DSC",	
	  "telephone quality audio",
	  ProbeGeneric, DT_GENERIC },
    { "zs",
	  "Zilog 8530",	
	  "serial communications chip",
	  ProbeGeneric, DT_GENERIC },
    { "mti",
	  "ALM-1 (Systech MTI-1600)",	
	  "16-line terminal multiplexer",
	  ProbeGeneric, DT_GENERIC },
    { "mcp",
	  "ALM-2 (Sun MCP/ALM)",	
	  "16-line terminal multiplexer",
	  ProbeGeneric, DT_GENERIC },
    { "fpa",
	  "Sun-3 FPA",	
	  "Weitek-based floating point accelerator",
	  ProbeGeneric, DT_GENERIC },
    { "des",
	  "AmZ8068 Data Ciphering Processor",
	  "NBS Data Encryption Standard",
	  ProbeGeneric, DT_GENERIC },
    { "vpc",
	  "Systech VPC-2200",	
	  "Versatec & Centronics printer/plotter interface",
	  ProbeGeneric, DT_GENERIC },
    { "pp",
	  "Parallel Port",
	  "Centronics-compatible parallel printer port",
	  ProbeGeneric, DT_GENERIC },
    { "SUNW,bpp",
	  "Sun Bidirectional Parallel Port",
	  NULL,
	  ProbeGeneric, DT_GENERIC },
    { "SUNW,lpvi",
	  "Sun Sbus Printer Card",
	  "laser printer video interface",
	  ProbeGeneric, DT_GENERIC },
    { "SUNW,DBRIe",
	  "Sun SpeakerBox & Dual Basic Rate ISDN",
	  "ISDN and Multimedia Codec",
	  ProbeGeneric, DT_GENERIC },
    { "db",
	  "Sun Dial Box",
	  NULL,
	  ProbeGeneric, DT_GENERIC },
    { "pr",
	  "PrestoServe",
	  "file system accelerator",
	  ProbeGeneric, DT_GENERIC },
    /*
     * Third Party devices
     */
    { "GNP,DEI",
	  "GNP DEI Serial Expander",	
	  "8 to 32 port terminal multiplexer",
	  ProbeGeneric, DT_GENERIC },
    /* 
     * Tadpole devices
     */
    { "SPARCbook",	NULL,	NULL,	ProbeGeneric, 	DT_NONE, DDT_LENCMP },
    { "nice",
	  "NICE Ethernet Co-processor",
	  "10Mb/sec Ethernet",
	  ProbeNetif },
    { "par",
	  "Parallel Port",
	  "Centronics-compatible parallel printer port", 
	  ProbeGeneric, DT_GENERIC },
    { "modem",
	  NULL,
	  "Hayes compatible modem",
	  ProbeGeneric, DT_GENERIC },
    { "mouse",
	  NULL,
	  "IBM compatible mouse",
	  ProbeGeneric, DT_GENERIC },
    { "urt",
	  NULL,
	  "serial communications chip",	
	  ProbeGeneric, DT_GENERIC },
    { "vga",	NULL,	NULL,		ProbeFrameBuffer },
    { "PC8",	NULL,	"8-bit",	ProbeGeneric, DT_BUS, DDT_NOUNIT },
    { "PC16",	NULL,	"16-bit",	ProbeGeneric, DT_BUS, DDT_NOUNIT },
    /*
     * Auspex devices
     */
    { "cpm",
	  "Clearpoint VME memory",
	  "Clearpoint VME memory board used as primary memory", 
	  ProbeGeneric, DT_GENERIC },
    { "apm",
	  "Auspex Primary Memory",
	  "Auspex VME memory board used as primary memory", 
	  ProbeGeneric, DT_GENERIC },
    { "aep",
	  "Auspex Ethernet Processor",
	  "Auspex Ethernet Processor board", 
	  ProbeGeneric, DT_GENERIC },
    { "ae",
	  "Ethernet Processor Lance Am7990",
	  "10MB/sec Ethernet", 
	  ProbeNetif },
    { "afp",
	  "Auspex File Processor",
	  "Auspex File Processor board", 
	  ProbeGeneric, DT_GENERIC },
    { "asp",
	  "Auspex Storage Processor",
	  "Auspex Storage Processor board", 
	  ProbeGeneric, DT_GENERIC },
    { "ad",	NULL,	NULL, ProbeSPDrive },
    { 0 },
};

#if	defined(HAVE_OPENPROM)
/*
 * Open Boot PROM device tables
 */
DEVDATATAB OBPdevices[] = {
    { "cpu",		NULL, NULL,	OBPprobeCPU },
    { 0 },
};

/*
 * Types of CPUs.
 *
 * The first element of each entity is the clock speed (in Mhz) of the
 * processor.  That combined with the second element determines what
 * the actual type of processor module is present (described by the
 * third element).
 */
NAMETAB CPUtypes[] = {
    { 40,	"Cypress,CY605",	"Model 100 SPARCmodule" },
    { 33,	"TI,TMS390Z50",		"SuperSPARC Model 20 SPARCmodule" },
    { 36,	"TI,TMS390Z50",		"SuperSPARC Model 30 SPARCmodule" },
    { 40,	"TI,TMS390Z55",		"SuperSPARC Model 41 SPARCmodule" },
    { 50,	"TI,TMS390Z55",		"SuperSPARC Model 50 SPARCmodule" },
    { 0,	"TI,TMS390S10",		"microSPARC" },
    { 0 },
};

/*
 * Table of OBP keywords that we want to provide a more
 * descriptive text for.
 */
NAMETAB OBPinfo[] = {
    { 0, "dblbuf",			"Double Buffered" },
    { 0, "iocache?",			"I/O Cache" },
    { 0, "mid",				"Module ID" },
    { 0, "mmu-nctx",			"Number of MMU Contexts" },
    { 0, "mmu-npmg",			"Number of MMU PMGs" },
    { 0, "multiple-cable-i/f?",		"Multiple Cable Interface" },
    { 0, "n-xdbus",			"Number of XDbus's" },
    { 0, "ncaches",			"Number of Caches" },
    { 0, "nmmus",			"Number of MMUs" },
    { 0, "scsi-initiator-id",		"SCSI Initiaiator ID" },
    { 0, "sparc-version",		"SPARC Version" },
    { 0, "vac-linesize",		"Virtual Address Cache Line Size" },
    { 0, "vac-size",			"Virtual Address Cache Size" },
    { 0, "vac_hwflush",			"Virtual Address Cache HW Flush" },
    { 0 },
};
#endif	/* HAVE_OPENPROM */

/*
 * Table of known Disk Controllers for Suns and other machines running
 * SunOS.
 * XXX - Auspex doesn't define DKC_AUSPEX_SP in current releases,
 * so we'll forcibly define it here for now.  It will be defined as 99
 * in a future release.  Put it at the end of the table, so that if
 * somebody else also uses 99, they get seen first if this is built
 * for their machine.
 */
#ifndef DKC_AUSPEX_SP
#define	DKC_AUSPEX_SP	99
#endif

DKCTLRTAB DkCtlrTab[] = {
/*
 * Sun
 */
#if 	defined(DKC_XY450) && defined(XY_READ)
    {  DKC_XY450,	"Xylogics 450/451 SMD",		XY_READ },
#endif
#if 	defined(DKC_ACB4000) && defined(SC_READ)
    {  DKC_ACB4000,	"Adaptec ACB4000 SCSI",		SC_READ },
#endif
#if	defined(DKC_MD21) && defined(SC_READ)
    {  DKC_MD21,	"Emulex MD21 SCSI",		SC_READ },
#endif
#if	defined(DKC_NCRFLOPPY) && defined(SC_READ)
    {  DKC_NCRFLOPPY,	"NCR Floppy SCSI",		SC_READ },
#endif
#if	defined(DKC_XD7053) && defined(XD_READ)
    {  DKC_XD7053,	"Xylogics 7053/753 SMD",	XD_READ },
#endif
#if	defined(DKC_SVx) && defined(XL_READ)
    {  DKC_SVx,		"Xylogics SV-{67}8xx IPI",	XL_READ },
#endif
#if	defined(DKC_SMSFLOPPY) && defined(SC_READ)
    {  DKC_SMSFLOPPY,	"SMS Floppy SCSI",		SC_READ },
#endif
#if	defined(DKC_SCSI_CCS) && defined(SC_READ)
    {  DKC_SCSI_CCS,	"SCSI CCS",			SC_READ },
#endif
#if	defined(DKC_CCS) && defined(SC_READ)
    {  DKC_CCS,		"CCS SCSI",			SC_READ },
#endif
#if	defined(DKC_NEC765)
    {  DKC_NEC765,	"NEC 765 Floppy",		-1 },
#endif
#if	defined(DKC_INTEL82072)
    {  DKC_INTEL82072,	"Intel 82072 Floppy",	 	-1 },
#endif
#if	defined(DKC_INTEL82077)
    {  DKC_INTEL82077,	"Intel 82077 Floppy",	 	-1 },
#endif
#if	defined(DKC_PANTHER) && defined(IP_READ)
    {  DKC_PANTHER,	"Sun ISP-80 (Panther) IPI-2",	IP_READ },
#endif
#if 	defined(DKC_CDROM)
    {  DKC_CDROM,	"CDROM",			-1 },
#endif
#if 	defined(DKC_WDC2880)
    {  DKC_WDC2880,	"WDC 2880",			-1 },
#endif
#if 	defined(DKC_DSD5215)
    {  DKC_DSD5215,	"DSD 5215",			-1 },
#endif
#if 	defined(DKC_MD)
    {  DKC_MD,		"Meta-Disk (Virtual Disk) Driver",		-1 },
#endif
#if 	defined(DKC_CDC_9057)
    {  DKC_CDC_9057,	"CDC 9057-321 (CM-3) IPI String Controller",	-1 },
#endif
#if 	defined(DKC_FJ_M1060)
    {  DKC_FJ_M1060,	"Fujitsu/Intellistor M1060 IPI-3 SC",		-1 },
#endif

/*
 * Solbourne
 */
#if	defined(DKC_XD753_IPI) && defined(XD_READ)
    {  DKC_XD753_IPI,	"Xylogics SV-{67}800 IPI",	XD_READ },
#endif
#if 	defined(DKC_IOASIC) && defined(SC_READ)
    {  DKC_IOASIC,	"IOASIC SCSI",			SC_READ },
#endif
#if 	defined(DKC_RF3500) && defined(SC_READ)
    {  DKC_RF3500,	"Ciprico RF-3500 SCSI",		SC_READ },
#endif
#if 	defined(DKC_VSCSI) && defined(SC_READ)
    {  DKC_VSCSI,	"Interphase V/SCSI",		SC_READ },
#endif

/*
 * Tadpole
 */
#if	defined(TADPOLE)
    { 19,		"PC IDE",			IDE_READ },
#endif	/* TADPOLE */

/*
 * Auspex
 */
#if	defined(DKC_AUSPEX_SP) && defined(SC_READ)
    {  DKC_AUSPEX_SP,	"Auspex Storage Processor",	SC_READ },
#endif
    { 0 },
};

/*
 * Table of known Sun Frame Buffers
 */
NAMETAB FBTab[] = {
#ifdef FBTYPE_SUN2BW
    {  FBTYPE_SUN2BW,		"Black & White memory",		"bwtwo" },
#endif
#ifdef FBTYPE_SUN2COLOR
    {  FBTYPE_SUN2COLOR,	"Color Graphics w/rasterop", 	"cgtwo" },
#endif
#ifdef FBTYPE_SUN2GP
    {  FBTYPE_SUN2GP,		"GS Graphics Processor", 	"cgtwelve" },
#endif
#ifdef FBTYPE_SUN5COLOR
    {  FBTYPE_SUN5COLOR,	"Sun-386i 8-bit Accelerated Color", "cgsix" },
#endif
#ifdef FBTYPE_SUN3COLOR
    {  FBTYPE_SUN3COLOR,	"8-bit Color",			"cgthree" },
#endif
#ifdef FBTYPE_MEMCOLOR
    {  FBTYPE_MEMCOLOR,		"B&W memory overlay plane",	"bwtwo" },
#endif
#ifdef FBTYPE_SUN4COLOR
    {  FBTYPE_SUN4COLOR,	"Color memory w/overlay",	"cgfour" },
#endif
#ifdef FBTYPE_SUNFAST_COLOR
    {  FBTYPE_SUNFAST_COLOR,	"GX 8-bit Accelerated Color",	"cgsix" },
#endif
#ifdef FBTYPE_SUNROP_COLOR
    {  FBTYPE_SUNROP_COLOR,	"24-bit Color w/rasterop",	"cgtwelve" },
#endif
#ifdef FBTYPE_SUNFB_VIDEO
    {  FBTYPE_SUNFB_VIDEO,	"Video Mixing",			"sunfb_video"},
#endif
#ifdef FBTYPE_SUNGIFB
    {  FBTYPE_SUNGIFB,		"Medical Imaging",		"sungifb" },
#endif
#ifdef FBTYPE_SUNGPLAS
    {  FBTYPE_SUNGPLAS,		"Plasma Panel",			"sungplas" },
#endif
#ifdef FBTYPE_SUNGP3
    {  FBTYPE_SUNGP3,		"24-bit Accelerated GPSI Color", "cgtwelve" },
#endif
#ifdef FBTYPE_SUNGT
    {  FBTYPE_SUNGT,		"24-bit Color Graphics Accelerator", "gt" },
#endif
/*
 * Tadpole frame buffer's
 */
#if	defined(TADPOLE)
#ifdef FBTYPE_NOTSUN1
    {  FBTYPE_NOTSUN1,		"VGA Graphics Card",		NULL },
#endif
#endif	/* TADPOLE */
    { 0 },
};

/*
 * Magnetic Tape Info.
 *
 * This info is based on <sys/mtio.h>.  It would be nice to just
 * use that info, but not all systems have MT_TAPE_INFO.
 */
NAMETAB MtInfo[] = {
#ifdef MT_ISCPC
    {  MT_ISCPC,		"TapeMaster 1/2-inch" },
#endif
#ifdef MT_ISXY
    {  MT_ISXY,			"Xylogics 472 1/2-inch" },
#endif
#ifdef MT_ISAR
    {  MT_ISAR,			"Archive QIC-11" },
#endif
#ifdef MT_ISSYSGEN11
    {  MT_ISSYSGEN11,		"Sysgen QIC-11" },
#endif
#ifdef MT_ISSYSGEN
    {  MT_ISSYSGEN,		"Sysgen QIC-24" },
#endif
#ifdef MT_ISMT02
    {  MT_ISMT02,		"Emulex MT-02 QIC-24" },
#endif
#ifdef MT_ISVIPER1
    {  MT_ISVIPER1,		"Archive QIC-150" },
#endif
#ifdef MT_ISWANGTEK1
    {  MT_ISWANGTEK1,		"Wangtek QIC-150" },
#endif
#ifdef MT_ISKENNEDY
    {  MT_ISKENNEDY,		"Kennedy 9612 1/2-inch" },
#endif
#ifdef MT_ISHP
    {  MT_ISHP,			"HP 88780 1/2-inch" },
#endif
#ifdef MT_ISEXABYTE
    {  MT_ISEXABYTE,		"Exabyte EXB-8200 8mm" },
#endif
#ifdef MT_ISEXB8500
    {  MT_ISEXB8500,		"Exabyte EXB-8500 8mm" },
#endif
#ifdef MT_ISWANGDAT
    {  MT_ISWANGDAT,		"WangDAT 3.81mm" },
#endif
#ifdef MT_ISWANGTHS
    {  MT_ISWANGTHS,		"Wangtek 4mm RDAT" },
#endif
#ifdef MT_ISPHYTHON
    {  MT_ISPHYTHON,		"Archive Python 4mm Helical Scan" },
#endif
    { 0 },
};

/*
 * Part information
 */
PARTINFO PARTtable[] = {
    { "SUNW,500-2015", "FSBE/S", 	"Fast SCSI Buffered Ethernet/Sbus", },
    { "SUNW,500-1902", "DSBE/S", 	"Differential SCSI Buffered Ethernet/Sbus", },
    { "SUNW,500-1869", "SBE/S",		"SCSI Buffered Ethernet/Sbus", },
    { "SUNW,520-1511", "SPC",		"Sun Serial Parallel Controller", },
    { 0 },
};
