/*
 * Copyright (c) 1992-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

/*
 * $Header: /src/common/usc/bin/sysinfo/RCS/os-aix.h,v 1.3 1993/06/08 18:15:07 mcooper Exp mcooper $
 */

#ifndef __os_aix_h__
#define __os_aix_h__

/*
 * IBM AIX
 */

#include <sys/file.h>
#include <sys/cfgdb.h>
#include <sys/cfgodm.h>

#define MAN_SHORT		"IBM"
#define MAN_LONG		"International Business Machines Corporation"
#ifdef _IBMR2
#	define CPU_NAME		"rios"
#endif
#define ARCH_TYPE		"rs6000"
#define KARCH_TYPE		ARCH_TYPE
#define HAVE_VARARGS
#define HAVE_NLIST
#define HAVE_UNAME
#define UNAME_REL_VER_COMB
#define NEED_KVM
#define VIRTMEM_TYPE		VIRTMEM_OSSPEC
#define PHYSMEM_TYPE		PHYSMEM_OSSPEC
#define _PATH_ODM		"/etc/objrepos"

/*
 * Directories where the catalog files of devices reside.
 * The file is usually called "devices.cat" and can be
 * found in "/usr/lib/methods" as well as "/usr/lib/nls/msg/%L"
 * The former usually contains a later version than the latter.
 */
#define ENV_NLSPATH \
"NLSPATH=/usr/lib/methods/%N:/usr/lib/nls/msg/%L/%N:/usr/lib/nls/msg/prime/%N"

/*
 * Name of default national language ($LANG)
 */
#define DEFAULT_LANG	"En_US"

/*
 * Node Name
 */
#define NN_SYS0		"sys0"

/*
 * Attribute strings
 */
#define AT_SIZE		"size"
#define AT_MODELCODE	"modelcode"
#define AT_REALMEM	"realmem"

/*
 * Vital Product Data Information
 */
struct _vpdinfo {
    char		       *code;
    char		       *title;
    char		       *value;
};
typedef struct _vpdinfo vpdinfo_t;

#endif	/* __aix_h__ */
