/*
 * Copyright (c) 1992-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

/*
 * $Header: /src/common/usc/bin/sysinfo/RCS/os-sunos4.h,v 1.8 1993/06/08 18:15:07 mcooper Exp mcooper $
 */

#ifndef __os_sunos4_h__
#define __os_sunos4_h__

/*
 * SunOS 4.x
 */

#include <stdio.h>
#include <mntent.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/file.h>
#include <machine/cpu.h>
#include <mon/idprom.h>
#include <sun/dkio.h>
#include <sun/dklabel.h>
#include <sun/fbio.h>
#include "info-sunos.h"

/*
 * What manufacturer is this?
 */
#if defined(TAD_SPBK_ARCH)
#	define MAN_SHORT	"Tadpole"
#	define MAN_LONG		"Tadpole Technology Inc"
#	define TADPOLE
#else
#if defined(CPU_TYPE_SERIES4) || defined(CPU_TYPE_SERIES5) || \
    	   defined(CPU_TYPE_SERIES5E) || defined(CPU_TYPE_SERIES6)
#	define MAN_SHORT	"Solbourne"
#	define MAN_LONG		"Solbourne Computer Corporation"
#	define SOLBOURNE
#else
#	define MAN_SHORT	"Sun"
#	define MAN_LONG		"Sun Microsystems Incorporated"
#	define HAVE_SUNROMVEC
#endif
#endif

#if defined(mc68020)
#	define ARCH_TYPE 	"sun3"
#	define HAVE_MAINBUS
#endif
#if defined(sparc)
#	define ARCH_TYPE 	"sun4"
#	if !defined(TADPOLE) && !defined(SOLBOURNE) && !defined(SUN4E_ARCH)
#		define HAVE_IPI
#	endif
#	if !defined(TADPOLE)
#		define HAVE_MAINBUS
#	endif
#endif
#if defined(i386)
#	define ARCH_TYPE 	"sun386"
#	define HAVE_MAINBUS
#endif
#if defined(OPENPROMS)
#	define HAVE_OPENPROM
#endif
#if !defined(SOLBOURNE)
#	define HAVE_IDPROM
#endif
#define NEED_SOCKIO
#define HAVE_VARARGS
#define HAVE_UNAME
#define HAVE_KVM
#define HAVE_NLIST
#define HAVE_NIT
#define HAVE_ANONINFO
#define HAVE_KARCHNAME
#define HAVE_KERNELVERSION
#define HAVE_PHYSMEM
#if !defined(SECSIZE)
#	define SECSIZE	512		/* Size of a disk sector */
#endif
#define KERNSTR_END	'\n'
/*
 * This is to get around an error on Sun386i's in <sun386/cpu.h>
 */
#if defined(SUN386_ARCH) && !defined(I386_ARCH)
#define I386_ARCH SUN386_ARCH
#endif

#include <sys/buf.h>

#if 	defined(TADPOLE)
#	include <taddev/ide_drvr_def.h>
#else	/* !TADPOLE */
#	if 	defined(HAVE_IPI)
#		include <sundev/ipvar.h>
#	endif 	/* HAVE_IPI */
#	if	defined(XYLOGICS_IPI)
#		include <sundev/xlreg.h>
#		include <sundev/xlextensions.h>
#	endif	/* XYLOGICS_IPI */
#	include <sundev/xdreg.h>
#	include <sundev/xyreg.h>
#	include <sundev/scsi.h>
#	if 	defined(i386)
#		include <sundev/sdreg.h>
#	endif
#endif	/* TADPOLE */

#if defined(HAVE_MAINBUS)
#	include <sundev/mbvar.h>
#endif

#if defined(HAVE_OPENPROM)
#	include <sundev/openpromio.h>
#endif

/*
 * Types
 */
typedef struct dk_conf		DKconf;
typedef struct dk_geom		DKgeom;
typedef struct dk_info		DKinfo;
typedef struct dk_label		DKlabel;
typedef struct dk_type		DKtype;

#endif	/* __os_sunos4_h__ */
