/*
 * Copyright (c) 1992-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

/*
 * $Header: /src/common/usc/bin/sysinfo/RCS/os-sunos5.h,v 1.9 1993/06/08 18:15:07 mcooper Exp mcooper $
 */

#ifndef __os_sunos5_h__
#define __os_sunos5_h__

/*
 * SunOS 5.x
 */

#include <stdio.h>
#include <unistd.h>
#include <sys/fcntl.h>
#include <sys/param.h>
#include <sys/file.h>
#include <sys/cpu.h>
#include <sys/systeminfo.h>
#include <sys/idprom.h>
#include <sys/fbio.h>
#include <sys/mtio.h>
#include <sys/dkio.h>
#include <sys/hdio.h>
#include <sys/vtoc.h>
#include <sys/mnttab.h>
#include "info-sunos.h"

#if	!defined(SUNOS)
#define SUNOS 		5
#endif	/* SUNOS */

#if	!defined(ELF)
#define ELF 		1
#endif	/* ELF */

/*
 * What manufacturer is this?
 */
#if defined(TAD_SPBK_ARCH)
#	define TADPOLE
#else
#if defined(CPU_TYPE_SERIES4) || defined(CPU_TYPE_SERIES5) || \
    	   defined(CPU_TYPE_SERIES5E) || defined(CPU_TYPE_SERIES6)
#	define SOLBOURNE
#else
#	define HAVE_SUNROMVEC
#endif
#endif

#define HAVE_OPENPROM
#define NEED_SOCKIO
#define HAVE_IDPROM
#define HAVE_VARARGS
#define HAVE_UNAME
#define HAVE_KVM
#define HAVE_NLIST
#define HAVE_DLPI
#define HAVE_SYSINFO
#define HAVE_MEMSET
#define HAVE_STRCHR
#define HAVE_ANONINFO
#define PHYSMEM_TYPE		PHYSMEM_OSSPEC

/*
 * Paths
 */
#define _PATH_DEV		"/dev"
#define _PATH_DEV_RDSK		"/dev/rdsk"
#define _PATH_DEV_RMT		"/dev/rmt"
#define _PATH_DEV_FBS		"/dev/fbs"

#if defined(HAVE_OPENPROM)
#	include <sys/openpromio.h>
#endif

/*
 * Types
 */
typedef struct vtoc		DKvtoc;
typedef struct dk_cinfo		DKcinfo;
typedef struct dk_geom		DKgeom;
typedef struct hdk_type		DKtype;

#endif	/* __os_sunos5_h__ */
